
var Bing = Microsoft.Maps;
var mapCredential = 'AvVtoL6WVsQzl-3kfAoxAPR9gnJ_yh5TS6Pf0T59fMrzv86oq2qRRz5jWXqC7kWe';
var map; 
$(document).ready(docReady);

function docReady() {
    loadMap();
    $('#search_form').submit(doSearch);
	$('#publish_form').submit(doPublish);
    Bing.Events.addHandler(map, 'mousedown', mapOnMouseDown);
    Bing.Events.addHandler(map, 'mouseup', mapOnMouseUp);
    pinsInfo = new Array();
    subDistances = new Array();
}

function loadMap() {
    map = new Bing.Map($('#map_body')[0], {
		credentials: mapCredential,
		center: new Bing.Location(35.69, 139.7),
		zoom: 12,
		mapTypeId:Microsoft.Maps.MapTypeId.road
	});
}

function mapOnMouseDown(e) {
    mouseDownLocation = new Bing.Point(e.pageX, e.pageY);
}

function mapOnMouseUp(e) {
    var pixel = new Bing.Point(e.pageX, e.pageY);
    if (mouseDownLocation != null
		&& mouseDownLocation.x == pixel.x
		&& mouseDownLocation.y == pixel.y) {

		var pinIndex = pinsInfo.length + 1;
		var loc = map.tryPixelToLocation(pixel, Microsoft.Maps.PixelReference.page);
        var pushpin = new Microsoft.Maps.Pushpin(loc, {text:String(pinIndex)});
        map.entities.push(pushpin);

		var dist;
		if (pinsInfo.length > 0) {
			var lastPin = pinsInfo[pinsInfo.length-1];
			dist = calcDistance(lastPin.getLocation(), loc);
			subDistances.push(dist)
			calcTotalDistance();
		} else {
			dist = ""
		}
		pinsInfo.push(pushpin);
		var lat = loc.latitude;
		var lon = loc.longitude;
		var html = '<tr><td>' + pinIndex
			+ "</td><td>" + lat
			+ "</td><td>" + lon
			+ "</td><td>" + dist
			+ "</td></tr>";
		$('#pins_list tbody').append(html);
    }
}

function calcTotalDistance() { 
    var total = 0.0;
    for (var i = 0; i < subDistances.length; i++) {
		total += subDistances[i];
    }
    $('#total_result').text(total);
}

function calcDistance(Loc1, Loc2) { 
    var lat1 = Loc1.latitude;
    var lon1 = Loc1.longitude;
    var lat2 = Loc2.latitude;
    var lon2 = Loc2.longitude;
    var latDif = Math.PI / 180 * (lat2 - lat1);
    var lonDif = Math.PI / 180 * (lon2 - lon1);
    var vertDist = 6378.137 * latDif;
    var horzDist = Math.cos(Math.PI / 180 * lat1) * 6378.137 * lonDif;
    var dist = Math.sqrt(vertDist*vertDist + horzDist*horzDist);

    return dist;
}

function doSearch() {
    map.getCredentials(callSearchService);  
    return false;
}

function callSearchService(credentials) {
    var reqUrl = 'http://dev.virtualearth.net/REST/v1/Locations/'
    var data = {
		query: $('#query_text').val(),
		key: credentials,
    }
    $.ajax({
        type: "GET",
        url: reqUrl,
        dataType: "jsonp",
        data: data,
        jsonp: "jsonp",
        success: function (data, dataType) {
            searchCallback(data);
        }
    });
}

function searchCallback(resp) {
    if (resp &&
        resp.resourceSets &&
        resp.resourceSets.length > 0 &&
        resp.resourceSets[0].resources &&
        resp.resourceSets[0].resources.length > 0) {

        var bbox = resp.resourceSets[0].resources[0].bbox;
        var viewBoundaries = Microsoft.Maps.LocationRect.fromLocations(new Microsoft.Maps.Location(bbox[0], bbox[1]), new Microsoft.Maps.Location(bbox[2], bbox[3]));
        map.setView({ bounds: viewBoundaries});

    } else {
		alert("no result found or error cccured.");
    }
}

// Send pins data to publish
function doPublish() {
	var data = {locations: new Array()};
	for (var i = 0; i < pinsInfo.length; i++) {
		loc = pinsInfo[i].getLocation();
		data["locations"].push({
			latitude: loc.latitude,
			longitude: loc.longitude
		});
	}
	$.post("/publish/", data, donePublish, "text");
	return false;
}

function donePublish(data) {
	var result_str = 'route published. url: <a href="/published/' + data + '/">/published/' + data + '</a>';
	$('#publish_result').html(result_str);
	$('#publish_button').attr("disabled", true);
}
